Index: pgapi30.c
===================================================================
RCS file: /usr/local/cvsroot/psqlodbc/psqlodbc/pgapi30.c,v
retrieving revision 1.22
diff -u -r1.22 pgapi30.c
--- pgapi30.c	13 Jul 2005 14:23:35 -0000	1.22
+++ pgapi30.c	25 Aug 2005 14:10:52 -0000
@@ -382,6 +382,9 @@
 			*((SQLUINTEGER *) Value) = SQL_FALSE;
 			break;
 		case SQL_ATTR_CONNECTION_DEAD:
+#ifdef USE_LIBPQ
+			CC_is_server_alive(conn);
+#endif 	/* USE_LIBPQ */
 			*((SQLUINTEGER *) Value) = (conn->status == CONN_NOT_CONNECTED || conn->status == CONN_DOWN);
 			break;
 		case SQL_ATTR_CONNECTION_TIMEOUT:
Index: connection.c
===================================================================
RCS file: /usr/local/cvsroot/psqlodbc/psqlodbc/connection.c,v
retrieving revision 1.106
diff -u -r1.106 connection.c
--- connection.c	12 Aug 2005 09:47:54 -0000	1.106
+++ connection.c	25 Aug 2005 14:08:06 -0000
@@ -3336,6 +3336,26 @@
 		return qres;
 }
 
+void
+CC_is_server_alive(ConnectionClass *conn)
+{
+	PGresult *res;
+	if((PQstatus(conn->pgconn)) != CONNECTION_OK)
+		conn->status = CONN_NOT_CONNECTED;
+	res = PQexec(conn->pgconn,"SELECT 1");
+	if(PQresultStatus(res) != PGRES_TUPLES_OK)
+	{
+		PQclear(res);
+		conn->status = CONN_DOWN;
+	}
+	else
+	{
+		PQclear(res);
+		conn->status = CONN_CONNECTED;
+	}
+
+}
+
 
 #endif /* USE_LIBPQ */
 
Index: libpqconnection.h
===================================================================
RCS file: /usr/local/cvsroot/psqlodbc/psqlodbc/libpqconnection.h,v
retrieving revision 1.3
diff -u -r1.3 libpqconnection.h
--- libpqconnection.h	12 Aug 2005 09:19:42 -0000	1.3
+++ libpqconnection.h	25 Aug 2005 14:05:22 -0000
@@ -408,6 +408,7 @@
 int			LIBPQ_connect(ConnectionClass *self);
 QResultClass		*LIBPQ_execute_query(ConnectionClass *self,char *query);
 QResultClass		*CC_mapping(ConnectionClass *self,PGresult *pgres,QResultClass *qres);
+void 		CC_is_server_alive(ConnectionClass *conn);
 /* CC_send_query options */
 #define	CLEAR_RESULT_ON_ABORT	1L
 #define	CREATE_KEYSET		(1L << 1) /* create keyset for updatable curosrs */
